//+-----------------------------------------------------------------------+
//|                                                   BrainTrend1Stop.mq4 |
//|                                   Copyright  2005. Alejandro Galindo |
//|                                                   http://elCactus.com |
//+-----------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

//---- input parameters
extern int HistoryMax= 500;
extern int AveragePeriod= 10;
extern int Reg= 1;

//---- buffers
double Buffer1[];
double Buffer2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //---- indicator line
   IndicatorBuffers(2);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,Buffer1);
   SetIndexArrow(0,158);

   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,Buffer2);
   SetIndexArrow(1,158);

   //----
   return(0);
}
  
//+------------------------------------------------------------------+
//| BrainTrend1Stop                                                  |
//+------------------------------------------------------------------+
int start()
{
  
   int i,shift, lastbar, 
        swing_in= 30, // extra 30 bars for swing in
        counted_bars= IndicatorCounted();
        
   double value=0, price=0, close, trend=0, dK=0, avgrange=0, watr= 0;
  
   lastbar= MathMin(HistoryMax, Bars-AveragePeriod-swing_in-1);

   SetIndexDrawBegin(0, Bars-lastbar);
   SetIndexDrawBegin(1, Bars-lastbar);   

   // some start values to begin with
   watr=  AvgRange(0, AveragePeriod);
   
   price= (High[lastbar+swing_in]+Low[lastbar+swing_in])/2;
   value= price;
   
   for (shift= lastbar+swing_in; shift>=0; shift--) {

      Buffer1[shift]= 0; 
      Buffer2[shift]= 0; 

      if (Reg==2) {
         watr= AvgRange(shift, AveragePeriod);
      }
      
      close= Close[shift];

      if (trend >= 0) {
      
         price= MathMax(price, close);
         value= price * (1 - watr);
         
         if (close < value) {
             price= close;
             value= price * (1 + watr);
             trend= -1;
         }
       } 
       else 
       if (trend <= 0) {
       
         price= MathMin(price, close);
         value= price * (1 + watr);
         
         if (close > value) {
            price= close;
            value= price * (1 - watr);
            trend= 1;
         }
      }

      if (shift<=lastbar) {
         if (trend==-1) { 
            Buffer1[shift]= value; 
         }
         
         if (trend==1) { 
            Buffer2[shift]= value; 
         }
      }
   }
   
   return(0);
}


//+------------------------------------------------------------------+
//| custom weighted atr/deviation                                    |
//+------------------------------------------------------------------+
double AvgRange(int bar, int period)
{
   double watr= 0, dk, 
          avgrange=0;
   
   for (int i=1; i<=period; i++) { 
      dk = 1+(period-i)/period;
      avgrange+= dk*MathAbs(High[bar+i]-Low[bar+i]);      
   }

   watr= avgrange/period; 
   
   if (Point>=0.01) 
      watr*= Point; 
  
   return (watr);
}

//+------------------------------------------------------------------+


